// this is the version of the open economy in which welfare is maximized
// no output is graphed. Instead, impulse responses are stored for use by plotcomparisons.m
// of course, this code can be used as a stand-alone, and with some modifications could graphs the results.

// Endogenous variables 
var lpmcU lpcU lqU lpxU lRU lcU lpsizplusU lpiU lsU aU lHU lwbarU 
lphaloU lFdU lpitildedpiU lKdU Welf Util lyU lpicU
 
// Exogenous variables 
    lzetacU lmuzU lzetahU lRstarU lepsilonU lystarU lgU ltaudU lpitargetU 
lpistarU phitildeU

    lmult1,  lmult2,  lmult3,  lmult4,  lmult5,  lmult6,  lmult7,   
    lmult8,  lmult9,  lmult10,  lmult11,  lmult12,  lmult13,  lmult14,   
    lmult15,  lmult16,  lmult17; 


varexo lzetacU_eps lmuzU_eps lzetahU_eps lRstarU_eps lepsilonU_eps  
lystarU_eps lgU_eps ltaudU_eps lpitargetU_eps lpistarU_eps phitildeU_eps 
money_eps; 
 
parameters nustar beta muz xid lambdad kappad vrkappad 
 pibreve epsilon taud nu vrphi nux omegac etac zetac zetah AL b etag etaa 
 sigmaL phitildea phitildes etaf rhoR rpi ry rdeltapi rdeltay rq  
 nbeta lambday lambdadeltaR lambdaS Welf_SS Util_SS 
 lpmcU_SS lpcU_SS lqU_SS lRstarU_SS lpxU_SS lRU_SS lcU_SS lpsizplusU_SS lpiU_SS lsU_SS aU_SS lHU_SS lwbarU_SS 
 lphaloU_SS lFdU_SS lpitildedpiU_SS lKdU_SS  
 lzetacU_SS lmuzU_SS lzetahU_SS lRstarU_SS lepsilonU_SS lystarU_SS lgU_SS ltaudU_SS lpitargetU_SS 
 lpistarU_SS lyU_SS phitildeU_SS
    lmult1_SS,  lmult2_SS,  lmult3_SS,  lmult4_SS,  lmult5_SS,   
           lmult6_SS,  lmult7_SS,  lmult8_SS,  lmult9_SS,  lmult10_SS,   
           lmult11_SS,  lmult12_SS,  lmult13_SS,  lmult14_SS,  lmult15_SS,   
           lmult16_SS,  lmult17_SS; 
 
params;


[lpicU_SS,Welf_SS,Util_SS,lpmcU_SS,lpcU_SS,lqU_SS, ...
lpxU_SS,lRU_SS, ...
lcU_SS,lpsizplusU_SS,lpiU_SS,lsU_SS,aU_SS,lHU_SS,lwbarU_SS ...
,lphaloU_SS,lFdU_SS,lpitildedpiU_SS,lKdU_SS, ...
lzetacU_SS,lmuzU_SS,lzetahU_SS,lRstarU_SS,lepsilonU_SS,lystarU_SS, ...
lgU_SS,ltaudU_SS,lpitargetU_SS ...
,lpistarU_SS,lyU_SS,phitildeU_SS,lmarkupU_SS] = steadyss(beta,'basesimplewelf_out_lmss');
basesimplewelf_out_lmss;
   
model; 

//1 eqsimple 2 
lpmcU-lpcU-lqU-log(nustar*exp(lRstarU)+1-nustar); 
 
// 2 eqsimple 3 
log(nux*exp(lRU)+1-nux)-lqU-lpcU-lpxU; 
 
// 3 eqsimple 4 
exp(lzetacU)/(exp(lcU)-b*exp(lcU(-1))/exp(lmuzU))-  
beta*b*(exp(lzetacU(+1))/  
(exp(lcU(+1))*exp(lmuzU(+1))-b*exp(lcU)))  
-exp(lpsizplusU)*exp(lpcU)=0; 
 
// 4 eqsimple 5 
exp(lpsizplusU)-beta*exp(lpsizplusU(+1)+lRU-lpiU(+1)-lmuzU(+1)); 
 
// 5 eqsimple 6 
-exp(lpsizplusU)+beta*exp(lpsizplusU(+1))/(exp(lmuzU(+1))*exp(lpiU(+1)))  
*(exp(lsU(+1))*exp(lRstarU)*  
exp(-phitildea*(aU-aU_SS)-phitildes*(exp(lRstarU)-exp(lRU)-(exp(lRstarU_SS)-exp(lRU_SS)))+phitildeU)); 
 
// 6 eqsimple 7 
exp(lzetahU+sigmaL*lHU-lpsizplusU)*AL-exp(lwbarU); 
 
// 7 eqsimple 8 
lyU = (lambdad/(lambdad-1))*lphaloU + lepsilonU + lHU; 
 
// 8 eqsimple 9 
aU+exp(lpmcU)*omegac*exp(etac*(lpcU-lpmcU)+lcU) 
  = exp(lqU+lpcU+(1-etaf)*lpxU+lystarU) + exp(lRstarU(-1)-phitildea*(aU(-1)-aU_SS)  
  -phitildes*(exp(lRstarU(-1))-exp(lRU(-1))-(exp(lRstarU_SS)-exp(lRU_SS)))  
  +phitildeU(-1))*exp(lsU-lpiU-lmuzU)*aU(-1);   
 
// 9 eqsimple 10 
-exp(lyU) + exp(lgU) + (1-omegac)*exp(lpcU*etac+lcU) + exp(-etaf*lpxU+lystarU); 
 
// 10 eqsimple 12 
exp(lpicU)=exp(lpiU)*  
((1-omegac+omegac*(exp(lpmcU))^(1-etac))/  
(1-omegac+omegac*(exp(lpmcU(-1)))^(1-etac)))^(1/(1-etac));  
 
//Non-linear pricing equations for domestic intermediate goods producer  
//11 eq40a  
exp(lFdU)-exp(lpsizplusU+lyU)-beta*xid*exp(lpitildedpiU(+1)/(1-lambdad)+lFdU(+1));  
  
//12 eq40b  
exp(lKdU)-lambdad*exp(lpsizplusU+lyU+ltaudU+lwbarU+log(nu*exp(lRU)+1-nu)-lepsilonU)  
-beta*xid*exp(lpitildedpiU(+1)*lambdad/(1-lambdad)+lKdU(+1));  
 
//13 eq40c  
exp(lphaloU*lambdad/(1-lambdad))-(1-xid)*((1-xid*exp(lpitildedpiU/(1-lambdad)))/(1-xid))^lambdad  
   -xid*(exp(lpitildedpiU+lphaloU(-1)))^(lambdad/(1-lambdad));  
  
//14 eq40d  
exp(lKdU-lFdU)=((1-xid*exp(lpitildedpiU/(1-lambdad)))/(1-xid))^(1-lambdad);  
  
//15 eq40e  
exp(lpitildedpiU)=exp(-lpiU+kappad*lpiU(-1)+(1-kappad-vrkappad)*lpitargetU+vrkappad*log(pibreve));  
 
// 16 
// Policymaker's First-Order Conditions 
-lmult5*beta*exp(lpsizplusU(+1))/exp(lmuzU(+1))/exp(lpiU(+1))*exp(lsU(+1))*exp(lRstarU)*phitildea*exp(-phitildea*(aU-aU_SS)-phitildes*(exp(lRstarU)-exp(lRU)-exp(lRstarU_SS)+exp(lRU_SS))+phitildeU)+lmult8+nbeta*lmult8(+1)*(phitildea*exp(lRstarU-phitildea*(aU-aU_SS)-phitildes*(exp(lRstarU)-exp(lRU)-exp(lRstarU_SS)+exp(lRU_SS))+phitildeU)*exp(lsU(+1)-lpiU(+1)-lmuzU(+1))*aU-exp(lRstarU-phitildea*(aU-aU_SS)-phitildes*(exp(lRstarU)-exp(lRU)-exp(lRstarU_SS)+exp(lRU_SS))+phitildeU)*exp(lsU(+1)-lpiU(+1)-lmuzU(+1))); 
exp(lzetacU)*exp(lmuzU+lcU)/(exp(lmuzU+lcU)-b*exp(lcU(-1)))-nbeta*exp(lzetacU(+1))*b*exp(lcU)/(exp(lmuzU(+1)+lcU(+1))-b*exp(lcU))+lmult3*(-exp(lzetacU)/(exp(lcU)-b*exp(lcU(-1))/exp(lmuzU))^2*exp(lcU)-beta*b^2*exp(lzetacU(+1))/(exp(lcU(+1))*exp(lmuzU(+1))-b*exp(lcU))^2*exp(lcU))+1/nbeta*lmult3(-1)*beta*b*exp(lzetacU)/(exp(lcU)*exp(lmuzU)-b*exp(lcU(-1)))^2*exp(lcU)*exp(lmuzU)+nbeta*lmult3(+1)*exp(lzetacU(+1))/(exp(lcU(+1))-b*exp(lcU)/exp(lmuzU(+1)))^2*b*exp(lcU)/exp(lmuzU(+1))+lmult8*exp(lpmcU)*omegac*exp(etac*(lpcU-lpmcU)+lcU)+lmult9*(1-omegac)*exp(lpcU*etac+lcU); 
lmult11*exp(lFdU)-1/nbeta*lmult11(-1)*beta*xid*exp(lpitildedpiU/(1-lambdad)+lFdU)-lmult14*exp(lKdU-lFdU); 
-AL*exp(lzetahU+(1+sigmaL)*lHU)+lmult6*sigmaL*exp(lzetahU+sigmaL*lHU-lpsizplusU)*AL-lmult7; 
lmult12*exp(lKdU)-1/nbeta*lmult12(-1)*beta*xid*exp(lpitildedpiU*lambdad/(1-lambdad)+lKdU)+lmult14*exp(lKdU-lFdU); 
-lmult1-lmult2-lmult3*exp(lpsizplusU)*exp(lpcU)+lmult8*(exp(lpmcU)*omegac*etac*exp(etac*(lpcU-lpmcU)+lcU)-exp(lqU+lpcU+(1-etaf)*lpxU+lystarU))+lmult9*(1-omegac)*etac*exp(lpcU*etac+lcU)+lmult17*exp(lpcU); 
-lmult7*lambdad/(lambdad-1)+lmult13*lambdad/(1-lambdad)*exp(lphaloU*lambdad/(1-lambdad))-nbeta*lmult13(+1)*xid*exp(lpitildedpiU(+1)+lphaloU)^(lambdad/(1-lambdad))*lambdad/(1-lambdad); 
lmult10*exp(lpicU)+lmult16*exp(lsU)*exp(lpistarU)/exp(lpicU); 
-1/nbeta*lmult11(-1)*beta*xid/(1-lambdad)*exp(lpitildedpiU/(1-lambdad)+lFdU)-1/nbeta*lmult12(-1)*beta*xid*lambdad/(1-lambdad)*exp(lpitildedpiU*lambdad/(1-lambdad)+lKdU)+lmult13*((1-xid)*((1-xid*exp(lpitildedpiU/(1-lambdad)))/(1-xid))^lambdad*lambdad*xid/(1-lambdad)*exp(lpitildedpiU/(1-lambdad))/(1-xid*exp(lpitildedpiU/(1-lambdad)))-xid*exp(lpitildedpiU+lphaloU(-1))^(lambdad/(1-lambdad))*lambdad/(1-lambdad))+lmult14*((1-xid*exp(lpitildedpiU/(1-lambdad)))/(1-xid))^(1-lambdad)*xid*exp(lpitildedpiU/(1-lambdad))/(1-xid*exp(lpitildedpiU/(1-lambdad)))+lmult15*exp(lpitildedpiU); 
1/nbeta*lmult4(-1)*beta*exp(lpsizplusU+lRU(-1)-lpiU-lmuzU)-1/nbeta*lmult5(-1)*beta*exp(lpsizplusU)/exp(lmuzU)/exp(lpiU)*exp(lsU)*exp(lRstarU(-1))*exp(-phitildea*(aU(-1)-aU_SS)-phitildes*(exp(lRstarU(-1))-exp(lRU(-1))-exp(lRstarU_SS)+exp(lRU_SS))+phitildeU(-1))+lmult8*exp(lRstarU(-1)-phitildea*(aU(-1)-aU_SS)-phitildes*(exp(lRstarU(-1))-exp(lRU(-1))-exp(lRstarU_SS)+exp(lRU_SS))+phitildeU(-1))*exp(lsU-lpiU-lmuzU)*aU(-1)-lmult10*exp(lpiU)*((1-omegac+omegac*exp(lpmcU)^(1-etac))/(1-omegac+omegac*exp(lpmcU(-1))^(1-etac)))^(1/(1-etac))+lmult15*exp(-lpiU+kappad*lpiU(-1)+(1-kappad-vrkappad)*lpitargetU+vrkappad*log(pibreve))-nbeta*lmult15(+1)*kappad*exp(-lpiU(+1)+kappad*lpiU+(1-kappad-vrkappad)*lpitargetU(+1)+vrkappad*log(pibreve)); 
lmult1+lmult8*(exp(lpmcU)*omegac*exp(etac*(lpcU-lpmcU)+lcU)-exp(lpmcU)*omegac*etac*exp(etac*(lpcU-lpmcU)+lcU))-lmult10*exp(lpiU)*((1-omegac+omegac*exp(lpmcU)^(1-etac))/(1-omegac+omegac*exp(lpmcU(-1))^(1-etac)))^(1/(1-etac))*omegac*exp(lpmcU)^(1-etac)/(1-omegac+omegac*exp(lpmcU)^(1-etac))+nbeta*lmult10(+1)*exp(lpiU(+1))*((1-omegac+omegac*exp(lpmcU(+1))^(1-etac))/(1-omegac+omegac*exp(lpmcU)^(1-etac)))^(1/(1-etac))*omegac*exp(lpmcU)^(1-etac)/(1-omegac+omegac*exp(lpmcU)^(1-etac))-lmult17*(1-omegac+omegac*exp(lpmcU*(1-etac)))^(1/(1-etac))*omegac*exp(lpmcU*(1-etac))/(1-omegac+omegac*exp(lpmcU*(1-etac))); 
-lmult3*exp(lpsizplusU)*exp(lpcU)+lmult4*exp(lpsizplusU)-1/nbeta*lmult4(-1)*beta*exp(lpsizplusU+lRU(-1)-lpiU-lmuzU)-lmult5*exp(lpsizplusU)+1/nbeta*lmult5(-1)*beta*exp(lpsizplusU)/exp(lmuzU)/exp(lpiU)*exp(lsU)*exp(lRstarU(-1))*exp(-phitildea*(aU(-1)-aU_SS)-phitildes*(exp(lRstarU(-1))-exp(lRU(-1))-exp(lRstarU_SS)+exp(lRU_SS))+phitildeU(-1))-lmult6*exp(lzetahU+sigmaL*lHU-lpsizplusU)*AL-lmult11*exp(lpsizplusU+lyU)-lmult12*lambdad*exp(lpsizplusU+lyU+ltaudU+lwbarU+log(nu*exp(lRU)+1-nu)-lepsilonU); 
-lmult2+lmult8*(-1+etaf)*exp(lqU+lpcU+(1-etaf)*lpxU+lystarU)-lmult9*etaf*exp(-etaf*lpxU+lystarU); 
-lmult1-lmult2-lmult8*exp(lqU+lpcU+(1-etaf)*lpxU+lystarU)+lmult16*exp(lqU)/exp(lqU(-1))-nbeta*lmult16(+1)*exp(lqU(+1))/exp(lqU); 
lmult2*nux*exp(lRU)/(nux*exp(lRU)+1-nux)-lmult4*beta*exp(lpsizplusU(+1)+lRU-lpiU(+1)-lmuzU(+1))+lmult5*beta*exp(lpsizplusU(+1))/exp(lmuzU(+1))/exp(lpiU(+1))*exp(lsU(+1))*exp(lRstarU)*phitildes*exp(lRU)*exp(-phitildea*(aU-aU_SS)-phitildes*(exp(lRstarU)-exp(lRU)-exp(lRstarU_SS)+exp(lRU_SS))+phitildeU)-nbeta*lmult8(+1)*phitildes*exp(lRU)*exp(lRstarU-phitildea*(aU-aU_SS)-phitildes*(exp(lRstarU)-exp(lRU)-exp(lRstarU_SS)+exp(lRU_SS))+phitildeU)*exp(lsU(+1)-lpiU(+1)-lmuzU(+1))*aU-lmult12*lambdad*nu*exp(lRU)/(nu*exp(lRU)+1-nu)*exp(lpsizplusU+lyU+ltaudU+lwbarU+log(nu*exp(lRU)+1-nu)-lepsilonU); 
1/nbeta*lmult5(-1)*beta*exp(lpsizplusU)/exp(lmuzU)/exp(lpiU)*exp(lsU)*exp(lRstarU(-1))*exp(-phitildea*(aU(-1)-aU_SS)-phitildes*(exp(lRstarU(-1))-exp(lRU(-1))-exp(lRstarU_SS)+exp(lRU_SS))+phitildeU(-1))-lmult8*exp(lRstarU(-1)-phitildea*(aU(-1)-aU_SS)-phitildes*(exp(lRstarU(-1))-exp(lRU(-1))-exp(lRstarU_SS)+exp(lRU_SS))+phitildeU(-1))*exp(lsU-lpiU-lmuzU)*aU(-1)-lmult16*exp(lsU)*exp(lpistarU)/exp(lpicU); 
-lmult6*exp(lwbarU)-lmult12*lambdad*exp(lpsizplusU+lyU+ltaudU+lwbarU+log(nu*exp(lRU)+1-nu)-lepsilonU); 
lmult7-lmult9*exp(lyU)-lmult11*exp(lpsizplusU+lyU)-lmult12*lambdad*exp(lpsizplusU+lyU+ltaudU+lwbarU+log(nu*exp(lRU)+1-nu)-lepsilonU); 
 
// 17 
Util=exp(lzetacU)*log(exp(lmuzU+lcU)-b*exp(lcU(-1))) - AL*exp(lzetahU+ 
(1+sigmaL)*lHU)/(1+sigmaL);  
 
// 18  
Welf = Util + nbeta*Welf(+1); 
 
// 19 
exp(lqU)/exp(lqU(-1))=exp(lsU)*exp(lpistarU)/exp(lpicU); 
 
// 20 eq25 
exp(lpcU)-((1-omegac)+omegac*exp(lpmcU*(1-etac)))^(1/(1-etac)); 
 
// 21 - 31 
lzetacU = .95*lzetacU(-1) + lzetacU_eps; 
lmuzU = (1-.95)*lmuzU_SS + .95*lmuzU(-1) + lmuzU_eps; 
lzetahU = .95*lzetahU(-1) + lzetahU_eps; 
lRstarU = (1-.95)*lRstarU_SS + .95*lRstarU(-1) + lRstarU_eps; 
lystarU = (1-.95)*lystarU_SS + .95*lystarU(-1) + lystarU_eps; 
lpistarU = (1-.95)*lpistarU_SS + .95*lpistarU(-1) + lpistarU_eps; 
lepsilonU = .95*lepsilonU(-1) + lepsilonU_eps; 
lgU = (1-.95)*(log(etag)+lyU_SS) + .95*lgU(-1) + lgU_eps; 
ltaudU = (1-.95)*ltaudU_SS + .95*ltaudU(-1) + ltaudU_eps; 
lpitargetU = (1-.95)*lpitargetU_SS + .95*lpitargetU(-1) + lpitargetU_eps; 
phitildeU = .95*phitildeU(-1) + phitildeU_eps; 
end; 
 
 
 
shocks; 

var lzetacU_eps;
stderr 0;
var lmuzU_eps; 
stderr 0;
var lzetahU_eps;
stderr 0;
var lystarU_eps;
stderr 0;
var lpitargetU_eps;
stderr 0;
var lpistarU_eps;
stderr 0;
var money_eps;
stderr 0;

var ltaudU_eps;
stderr 0.01;
var phitildeU_eps;
stderr 0.01;
var lRstarU_eps;
stderr 0.01;
var lepsilonU_eps;
stderr 0.01;
var lgU_eps;
stderr 0.01;
end; 
 
initval; 
lpmcU=lpmcU_SS;
lpcU=lpcU_SS;
lqU=lpcU_SS;
lpxU=lpxU_SS;
lRU=lRU_SS;
lcU=lcU_SS;
lpsizplusU=lpsizplusU_SS;
lpitildedpiU=lpitildedpiU_SS; 
lpiU=lpiU_SS;
lsU=lsU_SS;
aU=aU_SS;
lHU=lHU_SS;
lwbarU=lwbarU_SS;
lphaloU=lphaloU_SS;
lFdU=lFdU_SS;
lKdU=lKdU_SS;
Welf=Welf_SS;
Util=Util_SS;
lyU=lyU_SS;
lpicU=lpicU_SS;
lzetacU=0;
lmuzU=lmuzU_SS;
lzetahU=0;
lRstarU=lRstarU_SS;
lystarU=lystarU_SS;
lpistarU=lpistarU_SS;
lepsilonU=0;
lgU=lgU_SS;
ltaudU=ltaudU_SS;
phitildeU = phitildeU_SS;
lpitargetU=lpitargetU_SS;
lmult1 = lmult1_SS; 
lmult2 = lmult2_SS; 
lmult3 = lmult3_SS; 
lmult4 = lmult4_SS; 
lmult5 = lmult5_SS; 
lmult6 = lmult6_SS; 
lmult7 = lmult7_SS; 
lmult8 = lmult8_SS; 
lmult9 = lmult9_SS; 
lmult10 = lmult10_SS; 
lmult11 = lmult11_SS; 
lmult12 = lmult12_SS; 
lmult13 = lmult13_SS; 
lmult14 = lmult14_SS; 
lmult15 = lmult15_SS; 
lmult16 = lmult16_SS; 
lmult17 = lmult17_SS; 
end; 
 
steady; 
 
stoch_simul(irf=20,order=1,nograph) lyU lcU lRU lHU lpiU lsU lqU aU Welf; 
 
%exch=cumsum(lsU_money_eps); 
%tt=0:length(exch)-1; 
%figure 
%plot(tt,exch) 
%axis tight 
%exch_bkwd0=exch; 
%save dornbkwd0 exch_bkwd0; 
 
SWRstar=[lyU_lRstarU_eps' 
 lcU_lRstarU_eps' 
 lRU_lRstarU_eps' 
 lHU_lRstarU_eps' 
 lpiU_lRstarU_eps' 
 lsU_lRstarU_eps' 
 lqU_lRstarU_eps' 
 aU_lRstarU_eps' 
 Welf_lRstarU_eps'+Welf_SS]; 
 
SWeps=[lyU_lepsilonU_eps' 
 lcU_lepsilonU_eps' 
 lRU_lepsilonU_eps' 
 lHU_lepsilonU_eps' 
 lpiU_lepsilonU_eps' 
 lsU_lepsilonU_eps' 
 lqU_lepsilonU_eps' 
 aU_lepsilonU_eps' 
 Welf_lepsilonU_eps'+Welf_SS]; 
 
SWg=[lyU_lgU_eps' 
 lcU_lgU_eps' 
 lRU_lgU_eps' 
 lHU_lgU_eps' 
 lpiU_lgU_eps' 
 lsU_lgU_eps' 
 lqU_lgU_eps' 
 aU_lgU_eps' 
 Welf_lgU_eps'+Welf_SS]; 
 
SWtaud=[lyU_ltaudU_eps' 
 lcU_ltaudU_eps' 
 lRU_ltaudU_eps' 
 lHU_ltaudU_eps' 
 lpiU_ltaudU_eps' 
 lsU_ltaudU_eps' 
 lqU_ltaudU_eps' 
 aU_ltaudU_eps' 
 Welf_ltaudU_eps'+Welf_SS]; 
 
SWphitilde=[lyU_phitildeU_eps' 
 lcU_phitildeU_eps' 
 lRU_phitildeU_eps' 
 lHU_phitildeU_eps' 
 lpiU_phitildeU_eps' 
 lsU_phitildeU_eps' 
 lqU_phitildeU_eps' 
 aU_phitildeU_eps' 
 Welf_phitildeU_eps'+Welf_SS]; 
 
save SW SWRstar SWeps SWg SWtaud SWphitilde Welf_SS; 