%this program runs all three dynare programs and plots the impulse
%responses so they can be compared.

dbstop if error
dynare basesimple
dynare basesimplewelf_out
dynare basesimpleLS_out
close all

varnames=['log output               '
          'log consumption          '
          'net interest rate        '
          'log, house               '
          'net inflation            '
          'log difference, S        '
          'log, real exchange       '
          'scaled, real net f assets'
          'Welf                     '];

responseto=['foreign interest rate'
            'neutral technology   '
            'gov''t spending       '
            'subsidy to mc        '
            'phitilde             '];

load LS LSRstar LSeps LSg LStaud LSphitilde Welf_SS; 
WelfLS=Welf_SS;
load SW SWRstar SWeps SWg SWtaud SWphitilde Welf_SS; 
WelfSW=Welf_SS;
load JT JTFWDRstar JTFWDeps JTFWDg JTFWDtaud JTFWDphitilde Welf_SS;
WelfJT=Welf_SS;

figure        
plothelp(varnames,LSRstar,SWRstar,JTFWDRstar,WelfLS,WelfSW,WelfJT,responseto,1)
figure
plothelp(varnames,LSeps,SWeps,JTFWDeps,WelfLS,WelfSW,WelfJT,responseto,2)
figure
plothelp(varnames,LSg,SWg,JTFWDg,WelfLS,WelfSW,WelfJT,responseto,3)
figure
plothelp(varnames,LStaud,SWtaud,JTFWDtaud,WelfLS,WelfSW,WelfJT,responseto,4)
figure
plothelp(varnames,LSphitilde,SWphitilde,JTFWDphitilde,WelfLS,WelfSW,WelfJT,responseto,5)